'''
Created on 2013-12-13

@author: Andrew Roth
'''
import shutil

def transfer_remote_file(job_manager, remote_host, in_file, out_file):
    '''
    Move a file from a in_file to a local file path using rsync.
    '''
    tmp_file = out_file + '.tmp'
    
    cmd = 'rsync'
    
    cmd_args = [
                '-L',
                '{0}:{1}'.format(remote_host, in_file),
                tmp_file
                ]
    
    job_manager.run_job(cmd, cmd_args)

    shutil.move(tmp_file, out_file)
